routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');
Route::resource('article', 'ArticleController');
Route::get('subscription/update{id}', 'SubscriptionController@update')->name('subscription.update');
Route::get('subscription/destroy{id}', 'SubscriptionController@destroy')->name('subscription.destroy');
Route::get('subscription/', 'SubscriptionController@index')->name('subscription.index');
Route::group(['middleware' => 'web'], function () {
    Route::post('article/store', 'ArticleController@store');
    Route::get('article/detroy', 'ArticleController@destroy');

});

app/Article.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Article extends Model
{
    protected $fillable = ['title','text','user_id'];
}

app/Subscription.php
<?php

namespace App;
use Illuminate\Database\Eloquent\Model;

class Subscription extends Model
{
    protected $fillable = ['author','subscriber'];
}

app/User.php
<?php

namespace App;

use Illuminate\Notifications\Notifiable;
use Illuminate\Foundation\Auth\User as Authenticatable;

class User extends Authenticatable
{
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'password',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];


}

app/Http/Controllers/ArticleController.php
<?php

namespace App\Http\Controllers;

use App\Article;
use App\Subscription;
use App\User;
use Auth;
use Illuminate\Http\Request;

class ArticleController extends Controller
{
    public function index()
    {
        $article = Article::all();
        $auth =  Auth::id();
        $users = User::all();
        $subscribes = Subscription::where('subscriber', '=', $auth)->get();
        return view('articles.articles',['article' => $article,'subscribes' => $subscribes,'users' => $users,'auth' => $auth]);
    }

    public function create()
    {
        return view('articles.create');
    }

    public function store(Request $request)
    {
        $article = new Article([
            'title' => $request->get('title'),
            'text' => $request->get('text'),
            'user_id' => Auth::user()->id
        ]);
        $article->save();
        return redirect('article');
    }

    public function show($id)
    {
        $user =  Auth::id();
        $article = Article::find($id);
        $author = $article->user_id;
        $permissed = false;
        if($author == $user){
            $permissed = true;
        }
        $subscribe = false;
        $subscribes = Subscription::where('subscriber', '=', $user)->get();
        foreach ($subscribes as $key => $value){
            $authors = $value->author;
            if($author == $authors){
                $subscribe = true;
                continue;
            }
        }
        return view('articles.article',['article' => $article,'permissed' => $permissed,'subscribe' => $subscribe]);
    }

    public function edit($id)
    {
        $article = Article::find($id);
        return view('articles.edit',['article' => $article]);
    }

    public function update($id,Request $request)
    {
        $article= Article::findOrFail($id);
        $input = $request->all();
        $article->fill($input)->save();
        return redirect('article');
    }

    public function destroy($id)
    {
        $article = Article::find($id);
        $article->delete();
        return redirect('article');
    }
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Routing\Controller as BaseController;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Foundation\Auth\Access\AuthorizesRequests;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/HomeController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

class HomeController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('home');
    }
}

app/Http/Controllers/SubscriptionController.php
<?php
namespace App\Http\Controllers;

use App\Article;
use App\Subscription;
use Auth;


class SubscriptionController extends Controller
{
    public function index()
    {
        $id = Auth::id();
        $article =[];
        $subscribe= Subscription::where('subscriber', '=', $id)->get();
        foreach ($subscribe as $key => $value) {
            $author = $value->author;
            $article[] = Article::where('user_id', '=', $author)->get();
        }
        return view('articles.tape',['article' => $article]);
    }

    public function update($id)
    {
        $subscription = new Subscription([
            'author' => Article::find($id)->user_id ,
            'subscriber' => Auth::user()->id
        ]);
        $subscription->save();
        return redirect('article');
    }

    public function destroy($id)
    {
        $subscripe= Subscription::where('author', '=', $id);
        $subscripe->delete();
        return redirect('article');
    }
}

resources/views/articles/article.blade.php
@extends('layouts.app')
@section('content')
<div class="container">
    <div class="jumbotron text-center">
        <h2>{{ $article->title }}</h2>
        <p>
            <strong>text:</strong> {{ $article->text }}<br>
        </p>
    </div>
    @if(!$subscribe && !$permissed)
    <a>
        {!! Form::open(['method' => 'GET','route' => ['subscription.update' , $article->id]]) !!}
        {!! Form::submit('Subscribe', ['class' => 'btn btn-small ']) !!}
        {!! Form::close() !!}
    </a>
    @endif
    @if($subscribe)
    <a>
        {!! Form::open(['method' => 'GET','route' => ['subscription.destroy' , $article->user_id]]) !!}
        {!! Form::submit('Unsubscription', ['class' => 'btn btn-small ']) !!}
        {!! Form::close() !!}
    </a>
    @endif
    @if($permissed)
    <a>
        {!! Form::open(['method' => 'DELETE','route' => ['article.destroy', $article->id]]) !!}
        {!! Form::submit('Delete', ['class' => 'btn btn-small btn-danger']) !!}
        {!! Form::close() !!}
    </a>
    <a class="btn btn-small btn-info" href="{{ URL::to('article/' . $article->id . '/edit') }}">Edit </a>
        @endif
</div>
@endsection

resources/views/articles/articles.blade.php
@extends('layouts.app')
@section('content')
    <div class="container">
        <h1 style="margin-bottom: 40px">All the Articles</h1>

        @foreach($article as $key => $value)
            <div class="panel panel-default">
                <div class="panel-body">
                    <div class="panel-heading"><h5>{{ $value->title  }}</h5>
                        @foreach($users as $field => $val)
                        @if(  $val->id == $value->user_id )
                        <div>
                           Author:  {{ $val->name }}
                        </div>
                        @endif
                        @endforeach
                        @foreach($subscribes as $object => $property)
                            @if( !isset($subscribes))
                                @if($value->user_id == $property->author)
                                <a>
                                    {!! Form::open(['method' => 'GET','route' => ['subscription.destroy' , $value->user_id]]) !!}
                                    {!! Form::submit('Unsubscription', ['class' => 'btn btn-small ']) !!}
                                    {!! Form::close() !!}
                                </a>
                                    @endif
                            @endif
                                @if( !isset($subscribes))
                                    @if($value->user_id != $property->author )
                            <a>
                                {!! Form::open(['method' => 'GET','route' => ['subscription.update' , $value->id]]) !!}
                                {!! Form::submit('Subscribe', ['class' => 'btn btn-small ']) !!}
                                {!! Form::close() !!}
                            </a>
                            @endif
                        @endif
                        @endforeach
                       </div>
                    <p>{{ $value->text }}</p>
                    <a class="btn btn-small btn-success" href="{{ URL::to('article/' . $value->id) }}">Show</a></div>
            </div>
        @endforeach
    </div>
@endsection

resources/views/articles/create.blade.php
@extends('layouts.app')
@section('content')
    <div class="container">
        <form method="POST" action="{{url('article/store')}}">
            <div class="form-group row">
                {{csrf_field()}}
                <label for="title" class="col-sm-2 col-form-label col-form-label-lg">Title</label>
                <div class="col-sm-10">
                    <input type="text" class="form-control form-control-lg"  placeholder="title" name="title">
                </div>
            </div>
            <div class="form-group row">
                <label for="text" class="col-sm-2 col-form-label col-form-label-sm">Post</label>
                <div class="col-sm-10">
                    <textarea name="text" rows="8" cols="80"></textarea>
                </div>
            </div>
            <div class="form-group row">
                <div class="col-md-2"></div>
                <input type="submit" class="btn btn-primary">
            </div>
        </form>
    </div>
@endsection

resources/views/articles/edit.blade.php
@extends('layouts.app')
@section('content')
    <div class="container">
        {!! Form::model($article, [
           'method' => 'PATCH',
           'route' => ['article.update', $article->id]
       ]) !!}
        <div class="form-group">
            {!! Form::label('title', 'Title:', ['class' => 'control-label']) !!}
            {!! Form::text('title', null, ['class' => 'form-control']) !!}
        </div>
        <div class="form-group">
            {!! Form::label('text', 'Text:', ['class' => 'control-label']) !!}
            {!! Form::text('text', null, ['class' => 'form-control']) !!}
        </div>
        {!! Form::submit('Update Title', ['class' => 'btn btn-primary']) !!}

        {!! Form::close() !!}
    </div>
@endsection

resources/views/articles/tape.blade.php
@extends('layouts.app')
@section('content')
<div class="container">
        <h1 style="margin-bottom: 40px">Articles by your authors</h1>
    @foreach($article as $key => $value)
        @foreach($value as $object=>$property)
            <div class=" col-2 col-sm-2 col-lg-2">
                <h5>{{ $property->title  }}</h5>
                <a class="btn btn-small btn-success" href="{{ URL::to('article/' . $property->id) }}">Show </a>
            </div><!--/span-->
        @endforeach
    @endforeach
</div>
@endsection

resources/views/home.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row">
        <div class="col-md-8 col-md-offset-2">
            <div class="panel panel-default">
                <div class="panel-heading">Dashboard</div>

                <div class="panel-body">
                    @if (session('status'))
                        <div class="alert alert-success">
                            {{ session('status') }}
                        </div>
                    @endif
                    You are logged in! Go in  <a href="{{ route('article.index') }}">all articles!</a>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/layouts/app.blade.php
<!DOCTYPE html>
<html lang="{{ app()->getLocale() }}">
<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- CSRF Token -->
    <meta name="csrf-token" content="{{ csrf_token() }}">

    <title>{{ config('app.name', 'Laravel') }}</title>

    <!-- Styles -->
    <link href="{{ asset('css/app.css') }}" rel="stylesheet">
</head>
<body>
    <div id="app">
        <nav class="navbar navbar-default navbar-static-top">
            <div class="container">
                <div class="navbar-header">

                    <!-- Collapsed Hamburger -->
                    <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#app-navbar-collapse">
                        <span class="sr-only">Toggle Navigation</span>
                        <span class="icon-bar"></span>
                        <span class="icon-bar"></span>
                        <span class="icon-bar"></span>
                    </button>
                    <!-- Branding Image -->
                    <a class="navbar-brand" href="{{ url('/') }}">
                       Home
                    </a>
                </div>
                <div class="collapse navbar-collapse" id="app-navbar-collapse">
                    <!-- Left Side Of Navbar -->
                    <ul class="nav navbar-nav">
                        &nbsp;
                    </ul>
                    <!-- Right Side Of Navbar -->
                    <ul class="nav navbar-nav navbar-right">
                        <!-- Authentication Links -->
                        <li> <a href="{{ route('article.index') }}">All articles</a></li>
                        @guest
                            <li><a href="{{ route('login') }}">Login</a></li>
                            <li><a href="{{ route('register') }}">Register</a></li>

                        @else
                           <li><a href="{{ route('subscription.index') }}">News feed</a></li>
                           <li><a  href="{{ URL::to('article/create') }}" >Create article </a></li>
                            <li class="dropdown">
                                <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-expanded="false">
                                    {{ Auth::user()->name }} <span class="caret"></span>
                                </a>
                                <ul class="dropdown-menu" role="menu">
                                    <li>
                                        <a href="{{ route('logout') }}"
                                            onclick="event.preventDefault();
                                                     document.getElementById('logout-form').submit();">
                                            Logout
                                        </a>
                                        <form id="logout-form" action="{{ route('logout') }}" method="POST" style="display: none;">
                                            {{ csrf_field() }}
                                        </form>
                                    </li>
                                </ul>
                            </li>
                        @endguest
                    </ul>
                </div>
            </div>
        </nav>

        @yield('content')
    </div>

    <!-- Scripts -->
    <script src="{{ asset('js/app.js') }}"></script>
</body>
</html>